mod character_controller;
mod mods;
mod timesys;

use bevy::prelude::*;
use bevy_console::ConsoleConfiguration;

use mods::mod_manager::ModManager;
mod console;

#[derive(Debug, Clone, Eq, PartialEq, Hash)]
enum AppState {
    Menu,
    InGame,
    ModMenu,
}

fn main() {
    // Load mods after play is pressed

    App::build()
        .insert_resource(Msaa { samples: 4 })
        .insert_resource(ClearColor(Color::rgb(0.4, 0.4, 0.4)))
        .insert_resource(WindowDescriptor {
            width: 1440.,
            height: 900.,
            title: "Lyrix".to_string(),
            vsync: true,
            ..Default::default()
        })
        .add_plugins(DefaultPlugins)
        .insert_resource(ConsoleConfiguration {
            // override config here
            ..Default::default()
        })
        // .add_state(AppState::Menu)
        .add_plugin(console::ConsoleManager)
        .add_plugin(ModManager)
        .add_plugin(character_controller::ModManager)
        .run();
}
